

from pandac.PandaModules import *


from VoxMap import *
from Renderer import *


class Chunk() :

    def __init__(self,  limit = (7,7,7), offset = (0,0,0)) :

        self.offset = offset
        self.limit = limit
        self.size = ( self.limit[0] - self.offset[0] + 1, self.limit[1] - self.offset[1] + 1, self.limit[2] - self.offset[2] + 1)
        self.v = 0
        self.t = 0
        self.r = 0
        self.gnp = NodePath()


    def clearNode(self) :        
        self.gnp.removeNode()
        
    def setVoxMap(self, voxmap) :
        self.v = voxmap
    
    def setTexPack(self, texpack) :  
        self.t = texpack
    
    def setRenderer(self, renderer) :
        self.r = renderer
    



    def getVertices(self, coords) :

        vertices = [
            #   0
            [(coords[0]+1,coords[1]+1,coords[2]+1),
            (coords[0]+1,coords[1],coords[2]+1),
            (coords[0]+1,coords[1]+1,coords[2]),
            (coords[0]+1,coords[1],coords[2])],
            #   1
            [(coords[0],coords[1],coords[2]+1),
            (coords[0],coords[1]+1,coords[2]+1),
            (coords[0],coords[1],coords[2]),
            (coords[0],coords[1]+1,coords[2])],
            #   2
            [(coords[0],coords[1]+1,coords[2]+1),
            (coords[0]+1,coords[1]+1,coords[2]+1),
            (coords[0],coords[1]+1,coords[2]),
            (coords[0]+1,coords[1]+1,coords[2])],
            #   3
            [(coords[0]+1,coords[1],coords[2]+1),
            (coords[0],coords[1],coords[2]+1),
            (coords[0]+1,coords[1],coords[2]),
            (coords[0],coords[1],coords[2])],
            #   4
            [(coords[0]+1,coords[1]+1,coords[2]+1),
            (coords[0],coords[1]+1,coords[2]+1),
            (coords[0]+1,coords[1],coords[2]+1),
            (coords[0],coords[1],coords[2]+1)],
            #   5
            [(coords[0]+1,coords[1],coords[2]),
            (coords[0],coords[1],coords[2]),
            (coords[0]+1,coords[1]+1,coords[2]),
            (coords[0],coords[1]+1,coords[2])],
        ]
        
        return vertices



    def drawGeom(self) :
        g = Geomizer()
        self.r.setGeomizer(g)

        for i in range(self.size[2]) :
            for j in range(self.size[1]) :
                for k in range(self.size[0]) :
                    x = k + self.offset[0]
                    y = j + self.offset[1]
                    z = i + self.offset[2]
                    pos = (x,y,z)
                    
#          Listage des faces a afficher
                    todraw = [0,0,0,0,0,0]
                    
                    if self.v.isInMap(pos) : 
                        if self.v.isToDraw(pos) :                            
                            if self.v.isPx(pos)  == False:
                                    todraw[0] = 1    
                            if self.v.isMx(pos)  == False:
                                    todraw[1] = 1    
                            if self.v.isPy(pos)  == False:
                                    todraw[2] = 1
                            if self.v.isMy(pos)  == False:
                                    todraw[3] = 1        
                            if self.v.isPz(pos)  == False:
                                    todraw[4] = 1   
                            if self.v.isMz(pos)  == False:
                                    todraw[5] = 1
                                                   
                        value = self.v.getValue(pos)
                        vertices = self.getVertices(pos)
                        self.r.addCube(todraw, vertices, value)
                                
        geom = self.r.getGeom()
        self.gnode = GeomNode('gnode')
        self.gnode.addGeom(geom)
        self.gnp = NodePath(self.gnode)
            
        self.gnp.setTexture(self.r.getTexture())

        return self.gnp


   
