

from direct.stdpy import threading

from direct.task import Task

from Chunk import *

from Utils import *

import copy


class Snake() :

    def __init__(self, voxmap, offset=(0,0,0), csize=(8,8,8), cnum=(5,5,5)) :

        self.offset = offset
        self.csize = csize
        self.cnum = cnum
        self.limit = [ offset[0] + (csize[0] *cnum[0]-1)  ,   offset[1] + (csize[1] *cnum[1]-1)     ,   offset[2] + (csize[2] *cnum[2]-1)      ]
  
        self.v = voxmap
        self.r = 0

        self.worktodo = False
        self.worklist = []
        
        self.mind = [[[ 0 for z in range (cnum[2]) ]  for y in range (cnum[1]) ] for x in range (cnum[0])  ]

        taskMgr.add(self.drawTask,"drawTask")
        
        
    def setRenderer(self, renderer) : 
        
        self.r = renderer
        
    def fillMind(self) :
        
        for x in range(self.cnum[0]) :
            for y in range(self.cnum[1]) :
                for z in range(self.cnum[2]) :
                    
                    chunk = Chunk(((x*self.csize[0] + self.csize[0] + self.offset[0]) , (y*self.csize[1] + self.csize[1] + self.offset[1]), (z*self.csize[2] + self.csize[2] + self.offset[2])),( (x*self.csize[0] + self.offset[0]), (y*self.csize[1] + self.offset[1]), (z*self.csize[2] + self.offset[2])))
                    chunk.setRenderer(self.r)
                    chunk.setVoxMap(self.v)
                    self.mind[x][y][z] = chunk

 

    def drawTask(self,  task):
        
#        task.delayTime = 0.03
        
        if self.worktodo == True :
            
            if len(self.worklist) > 0 :
                job = self.worklist.pop(0)
                job.clearNode()
                job.drawGeom()
                job.gnp.reparentTo(render)
            else :
                self.worktodo = False
        else :
            pass
        return task.cont
        
        
    
    def wake(self) :       

        for x in range (self.cnum[0]) :
            for y in range (self.cnum[1]) :
                for z in range (self.cnum[2]) :
                    
                    self.worklist.append(self.mind[x][y][z])

        self.worktodo = True
        
   
        
        
