import random

from panda3d.core import  *



class VoxMap() :

    def __init__(self,  limit = (63,63,63), offset = (0,0,0)) :

        self.offset = offset

        self.limit = limit

        self.data = [[[0 for i in range(self.limit[2]-self.offset[2]+1)] for j in range(self.limit[1]-self.offset[1]+1)] for k in range(self.limit[0]-self.offset[0]+1)]



    def isSolid(self, (x, y, z)) :
        x = int (x)
        y = int (y)
        z = int (z)        
        if self.isInMap((x,y,z)) :        
            if self.data[x][y][z] != 0 :
                return True
            else: 
                return False                
        else : return False
 


    def isToDraw(self, (x,y,z)) :         
        x = int (x)
        y = int (y)
        z = int (z)        
        if self.isInMap((x,y,z)) :
            if self.data[x][y][z] != 0 :
                return True
            else: 
                return False
        else : return False
            
 
 
    def isInMap(self, (x,y,z)) :
        if x < self.limit[0] and x >= self.offset[0] and y < self.limit[1] and y >= self.offset[1] and z < self.limit[2] and z >=  self.offset[2] : 
            return True            
        else : return False
 
 
    def getValue(self, (x, y, z)):
        x = int (x)
        y = int (y)
        z = int (z)
        if self.isInMap((x,y,z)) :            
            return self.data[x][y][z]
        else : return 0
 
 
 
    def isBurried(self, (x,y,z)) :
        
        pass
  


    def isPx(self, (x,y,z)) :        
        x = int (x + 1)
        y = int (y)
        z = int (z)                
        if self.isInMap((x,y,z)) :                        
            if self.data[x][y][z] != 0 :
                return True
            else: 
                return False                
        else : return False
 
 
    def isMx(self, (x,y,z)) :        
        x = int (x - 1)
        y = int (y)
        z = int (z)        
        if self.isInMap((x,y,z)) :            
            if self.data[x][y][z] != 0 :
                return True
            else: 
                return False
        else : return False
 
 
    def isPy(self, (x,y,z)) :        
        x = int (x)
        y = int (y + 1)
        z = int (z)
        if self.isInMap((x,y,z)) :            
            if self.data[x][y][z] != 0 :
                return True
            else: 
                return False
        else : return False


    def isMy(self, (x,y,z)) :        
        x = int (x)
        y = int (y - 1)
        z = int (z)
        if self.isInMap((x,y,z)) :
            
            if self.data[x][y][z] != 0 :
                return True
            else: 
                return False
        else : return False
        

    def isPz(self, (x,y,z)) :        
        x = int (x)
        y = int (y)
        z = int (z + 1)        
        if self.isInMap((x,y,z)) :            
            if self.data[x][y][z] != 0 :
                return True
            else: 
                return False
        else : return False
 
 
    def isMz(self, (x,y,z)) :
        x = int (x)
        y = int (y)
        z = int (z - 1)        
        if self.isInMap((x,y,z)) :            
            if self.data[x][y][z] != 0 :
                return True
            else: 
                return False
        else : return False
        
 


    def drawCube(self, size, color=1,   offset = (0,0,0)) :

        for i in range (size) :
            for j in range (size) :
                for k in range (size) :

                    self.data[k + offset[0]][j + offset [1]][i + offset[2]] = color                    
  
  
    def blueNoiseFill(self):
        
         for i in range (self.limit[2]+1) :
            for j in range (self.limit[1]+1) :
                for k in range (self.limit[0]+1) :
                    
                    lvl = int( i/4)
                    randy = random.randint (0,  i+1)
                    if randy == 1 :
 
                        self.data[k ][j ][i ] = 1

                    else : 
                        
                        self.data[k ][j ][i ] = 0
 
 
    def perlinFill(self) :
        
        p = ( PerlinNoise3(32, 32, 32))
            #        print p(0,1,2)
        
        for x in range (self.limit[0]+1) :
            for y in range (self.limit[1]+1) :
                for z in range (self.limit[2]+1) :
#                    pass
                    if p(x,y,z) >= 0.5 :
                        self.data[x][y][z] = 1
                    else :
                        self.data[x][y][z] =0
                        
 
 
    def  HMap01(self):
        
        p = PerlinNoise2(32, 32 )
        
        for x in range (self.limit[0]+1) :
            for y in range (self.limit[1]+1) :
                v =  p(x,y)
                mid = int ((self.limit[2]+1)/2)
                top = mid + (mid  * v)
                
                for z in range(int(top)) : 
                    self.data[x][y][z] = 1
                    
                    
        p2 = PerlinNoise3(16,16,16 )
        
        for x in range (self.limit[0]+1) :
            for y in range (self.limit[1]+1) :
                for z in range (self.limit[2]+1) :
                    
                    if self.data[x][y][z] != 0 :
                        v =  p2(x,y,z)
                        
                        if v > -0.5 : self.data[x][y][z] += 1 
                        
                        if v > 0 : self.data[x][y][z] += 1
                       
                        if v > 0.5 : self.data[x][y][z] += 1
                        
                        
               
