
import direct.directbase.DirectStart

from direct.showbase.DirectObject import DirectObject
from direct.showbase.ShowBase import ShowBase
from pandac.PandaModules import *

from direct.gui.OnscreenText import OnscreenText
from direct.filter.CommonFilters import CommonFilters


from Chunk import *
from VoxMap import *
from Snake import *
from Player import *
from Physix import *   
from Renderer import *


import sys



class World(DirectObject) :
    
    def __init__(self):
        
#        filters = CommonFilters(base.win, base.cam)
        
#        filters.setAmbientOcclusion()
        base.setBackgroundColor(0.4, 0.4, 0.5)
        
        myFog = Fog("Fog Name")
        myFog.setColor(0.3,0.3,0.5)
        myFog.setExpDensity(0.006)
        render.setFog(myFog)
        


        lens = base.camLens
        lens.setFilmSize(24, 36)
        lens.setFocalLength(16)
        base.cam.node().setLens(lens)

        
        
        self.text = TextNode('node name')
        self.text.setText("gna")
        textNodePath = aspect2d.attachNewNode(self.text)
        textNodePath.setScale(0.07)
        textNodePath.setPos(-1, 0, 0)
        
        self.accept('escape', sys.exit )#exit on esc

        
        # Create some lighting
        ambientLight = AmbientLight("ambientLight")
        ambientLight.setColor(Vec4(.2, .2, .3, 1))
        render.setLight(render.attachNewNode(ambientLight))


        directionalLight = DirectionalLight("directionalLight")
        directionalLight.setDirection(Vec3(-1, 0, -1))
        directionalLight.setColor(Vec4(0.9,0.9,1, 1))
        directionalLight.setSpecularColor(Vec4(1, 1, 1, 1))
        directionalLight.setShadowCaster(True, 12, 12) 

        render.setLight(render.attachNewNode(directionalLight))
        
        v = VoxMap((256,256,32))
        v.HMap01()
        t = TexPack("land02b.png" , 4)
        r = Renderer()
        r.setTexPack(t)
        
#        print r.t
#        
#        c = Chunk()
#
#        c.setVoxMap(v)
#        c.setRenderer(r)
#        gnp = c.drawGeom()
#        
#        gnp.reparentTo(render)
        
        s = Snake(v, (0,0,0), (8,8,32), (25,25,1))
        s.setRenderer(r)
        s.fillMind()
        s.wake()
        
        
        pos = (0 , 5.3, 2.7)
#        print v.isSolid(pos)
        
#        print v.isInMap(pos)
#        print v.isPx(pos)
        
        pos = (7,42,72)
        pos2 = (-3, -2, 13)
        
#        print v.isPx(pos)
        
#        print v.isInMap(pos)
#        print v.isInMap(pos2)
        
        def gameTask(self) :
            
            pass

w = World()
run()
